/**
 * Author : A.Lepe (dev@alepe.com) - intellisrc.com
 * License: MIT
 * Version: 2.2.1
 * Updated: 2024-03-15
 * Content: Core
 */

!function(e,t){"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?module.exports=t():e.m2d2=t()}(this,(function(){"use strict";class e{isString(e){return"string"==typeof e}isBool(e){return"boolean"==typeof e}isNumeric(e){return!isNaN(parseFloat(e))&&isFinite(e)}isSelectorID(e){return 0===(e+"").trim().indexOf("#")}isPlainObject(e){return"Object"===e.constructor.name}isObject(e){return"object"==typeof e}isArray(e){return Array.isArray(e)}isFunction(e){return"function"==typeof e}isElement(e){return e instanceof HTMLElement}isNode(e){return e instanceof Node||e instanceof DocumentFragment}isHtml(e){return-1!==(e+"").trim().indexOf("<")}isEmpty(e){return void 0===e||this.isObject(e)&&0===Object.keys(e).length||""===e}isVisible(e){if(!this.isElement(e))return console.log("(isVisible) Not an element: "),console.log(e),!1;const t="none"!==e.style.display,s="hidden"!==e.style.visibility;return t&&s}inView(e){const t=e.getBoundingClientRect();return t.top>=0&&t.left>=0&&t.bottom<=(window.innerHeight||document.documentElement.clientHeight)&&t.right<=(window.innerWidth||document.documentElement.clientWidth)&&t.width>0&&t.height>0}cleanArray(e){return e.filter((function(e){return 0===e||e}))}isValidElement(e){const t=this.newElement(e);return"template"!==e&&"HTMLUnknownElement"!==t.constructor.name}exists(e){return null!==document.querySelector(e)}getAttrOrProp(e,t){let s="";return this.hasAttrOrProp(e,t)&&(s=this.hasAttr(e,t)?e.getAttribute(t):e[t]),s}hasAttrOrProp(e,t){return this.hasAttr(e,t)||this.hasProp(e,t)}hasAttr(e,t){let s=!1;return e&&!this.isNumeric(t)&&(s="checked"===t?void 0!==e.type&&("radio"===e.type||"checkbox"===e.type):void 0!==e.hasAttribute&&e.hasAttribute(t)),s}hasProp(e,t){let s=!1;if(e&&!this.isNumeric(t)){let i=void 0!==e[t];i&&null===e[t]&&"value"===t&&(i=!1),s=i&&!(e[t]instanceof Node)&&!e.hasAttribute(t)}return s}setPropOrAttr(e,t,s){if(this.hasProp(e,t))try{e[t]=s}catch(i){this.setAttr(e,t,s)}else this.setAttr(e,t,s)}setAttr(e,t,s){s?e.setAttribute(t,s):e.removeAttribute(t)}defineProp(e,t,s){this.isObject(e)&&void 0===e[t]&&(Object.defineProperty(e,t,{enumerable:!1,writable:!0}),e[t]=s)}htmlElement(e){const t=this.newElement("template");return t.innerHTML=e.trim(),t.content.firstChild}newElement(e){return e&&!this.isNumeric(e)||(e="invalid"),document.createElement(e)}newEmptyNode(){return new DocumentFragment}getMethods(e){const t=Reflect.getPrototypeOf(e),s=Reflect.getPrototypeOf(t);return Reflect.ownKeys(t).filter((e=>Reflect.ownKeys(s).indexOf(e)<0))}appendAllChild(e,t){for(;e.firstChild;)t.append(e.firstChild)}prependAllChild(e,t){for(;e.firstChild;)t.prepend(e.firstChild)}}class t{"use strict";_stored={events:[],datasetNodes:[],datasets:[],styleNodes:[],styles:[]};static storedEventsTimeout=50;static short=!0;static updates=!0;static utils=new e;constructor(){["after","before","append","prepend","insertAdjacentElement","replaceWith"].forEach((e=>{Element.prototype["_"+e]=Element.prototype[e],Element.prototype[e]=function(...t){const s=Array.from(t);s.forEach(((e,t)=>{void 0!==e&&void 0!==e.domNode&&e.domNode instanceof Element&&(s[t]=e.domNode)})),this["_"+e].apply(this,s)}}))}static instance=new t;static extensions={};static main=(()=>{const e=(e,s)=>{const i=this.instance.getProxyNode(e,s||{});return i&&i.onready&&t.utils.isFunction(i.onready)&&(i.addEventListener("ready",i.onready,{once:!0}),setTimeout((()=>{i.dispatchEvent(new CustomEvent("ready"))}),10)),["dataset","style"].forEach((e=>{i&&i[e]&&(this.instance._stored[e+"s"].push(i[e]),this.instance._stored[e+"Nodes"].push(i))})),i};return t.utils.getMethods(t.utils).forEach((s=>{e[s]=t.utils[s]})),e})();static ready(e){document.addEventListener("DOMContentLoaded",(()=>{e(t.main)}))}static load(e){if(void 0!==e){const s=e(t.main);t.utils.isObject(s)&&!t.utils.isEmpty(s)&&Object.keys(s).forEach((e=>{if(t.utils.isValidElement(e)){void 0===t.extensions[e]&&(t.extensions[e]={});const i=t.utils.newElement(e);Object.keys(s[e]).forEach((s=>{t.utils.hasProp(i,s)&&console.log("Warning: property ["+s+"] already exists in node: ["+e+"] while trying to extend it. Unexpected behaviour may happen.")})),Object.assign(t.extensions[e],s[e])}else{void 0===t.extensions["*"]&&(t.extensions["*"]={});const i=t.utils.newElement("div");Object.keys(s[e]).forEach((e=>{t.utils.hasProp(i,e)&&console.log("Warning: property ["+e+"] already exists in Node while trying to extend it. Unexpected behaviour may happen.")})),Object.assign(t.extensions["*"],s[e])}}))}return t.main}extDom(e,s){if(!e)return console.error("Selector was empty"),null;void 0===s&&(s=document);const i=t.utils.isNode(e)?e:s.querySelector(e);if(!i)return t.utils.isString(e)?(console.error("Selector: "+e+" didn't match any element in node:"),console.log(s)):console.error("Node was null"),null;if(void 0===i._m2d2){i._m2d2=!0,["parent","sibling","posterior","anterior","find","findAll","onupdate","onready","show","onshow","inView","css","text","html","getData","index"].forEach((e=>{i.hasOwnProperty(e)&&(console.log("Node already had ["+e+"] property. It might cause unexpected behaviour."),console.log("You may need to update the M2D2 version or report it to: github.com/intellisrc/m2d2/"))})),Object.defineProperty(i,"text",{get(){return this.childNodes.length?this.innerText:this.textContent},set(e){if(this.childNodes.length){let t=!1;this.childNodes.forEach((s=>{"Text"===s.constructor.name&&(s.nodeValue=e,t=!0)})),t||this.prepend(document.createTextNode(e))}else this.textContent=e}}),Object.defineProperty(i,"html",{get(){return this.innerHTML},set(e){this.innerHTML=e}}),Object.defineProperty(i,"css",{get(){return this.classList},set(e){t.utils.isArray(e)?this.className=e.join(" "):t.utils.isString(e)?this.className=e:t.utils.isPlainObject(e)?Object.keys(e).forEach((t=>{e[t]?this.classList.add(t):this.classList.remove(t)})):console.error("Trying to assign a wrong value to css : "+e)}}),Object.defineProperty(i,"show",{get(){return t.utils.isVisible(this)},set(e){const s=()=>getComputedStyle(this,null).display,i=()=>{const e=document.getElementsByTagName("body")[0],t=document.createElement("template"),s=document.createElement(this.tagName);t.append(s),e.append(t);const i=getComputedStyle(s,null).display;return t.remove(),i};if(e){if("none"===s()){if(this._m2d2_display)this.style.display=this._m2d2_display;else if(this.style.removeProperty("display"),"none"===s()){const e=i();this.style.display=this.dataset.display||("none"!==e?e:"block")}void 0!==this.onshow&&t.utils.isFunction(this.onshow)&&this.onshow(this)}}else{const e="none"!==this.style.display?this.style.display:s();"none"!==e&&(this._m2d2_display=e),this.style.display="none"}}});let e={};return void 0!==t.extensions["*"]&&Object.assign(e,t.extensions["*"]),void 0!==t.extensions[i.tagName]&&Object.assign(e,t.extensions[i.tagName]),Object.assign(i,{inView:()=>t.utils.inView(i),posterior:()=>i.nextElementSibling,anterior:()=>i.previousElementSibling,parent:()=>this.extDom(i.parentElement),sibling:e=>i.parentElement.find(e),find:e=>{const t=i.querySelector(e);return t?this.extDom(t):null},findAll:e=>{const t=void 0===e?Array.from(i.children):i.querySelectorAll(e);return t.forEach((e=>{this.extDom(e)})),t}},e),void 0===i.index&&(i.index=()=>Array.from(i.parentNode.children).indexOf(i)),["INPUT","TEXTAREA","SELECT"].indexOf(i.tagName)>=0&&t.utils.hasAttrOrProp(i,"value")&&(i.oninput=function(){this.setAttribute("value",this.value)}),"FORM"===i.tagName&&(i.getData=function(e){const s={},n=new FormData(this),o=e||!1;for(let e of n.entries()){const n=i.find("[name='"+e[0]+"']");if(o||"hidden"===n.type||n.show){const i=e[0],o="file"===n.type?n.files:e[1];void 0!==s[i]?t.utils.isArray(s[i])?s[i].push(o):s[i]=[s[i],o]:s[i]=o}}return s}),i}return i}doDom(e,s){if(t.utils.isObject(e)&&void 0===s&&(s=e,e=t.utils.newEmptyNode(),void 0===s.warn&&(s.warn=!1)),!(t.utils.isString(e)||t.utils.isElement(e)||t.utils.isNode(e)))return console.error("Selector is not a string or a Node:"),console.log(e),null;if(t.utils.isString(e)&&!document.querySelector(e))return console.log("Selected element doesn't exists: "+e),null;const i=this.extDom(e);if(void 0===s)return i;if(s=this.plainToObject(i,s),Object.keys(s).filter((e=>!["tagName"].includes(e))).forEach((e=>{let n=s[e];null==n&&(console.log("Value was not set for key: "+e+", 'empty' was used in object: "),console.log(s),console.log("In node:"),console.log(i),n="");let o=this.updateValue(i,e,n),l=t.utils.hasProp(i,e),r=!1;if(t.utils.hasAttr(i,e)||l)switch(!0){case"value"===e&&t.utils.hasProp(i,"valueAsDate")&&o instanceof Date:e="valueAsDate";case"css"===e:case typeof o==typeof i[e]:case t.utils.isString(i[e])&&t.utils.isNumeric(o):case t.utils.isFunction(o)&&t.utils.isObject(i[e]):case t.utils.isBool(o)&&t.utils.isString(i[e]):case"object"==typeof i[e]&&"INPUT"===i.tagName:r=!0}if(r){let s=!1;switch(e){case"classList":t.utils.isArray(o)?o.forEach((t=>{i[e].add(t)})):t.utils.isString(o)?i[e].add(o):s=!0;break;case"style":case"dataset":t.utils.isPlainObject(o)?Object.keys(o).forEach((t=>{i[e][t]=this.updateValue(i[e],t,o[t])})):s=!0;break;default:switch(!0){case t.utils.isBool(o):case t.utils.hasAttrOrProp(i,e):t.utils.setPropOrAttr(i,e,o);break;default:i[e]=o}}s&&(console.error("Invalid value passed to '"+e+"': "),console.log(o),console.log("Into Node:"),console.log(i))}else{const l=[];try{if("template"!==e&&!t.utils.isFunction(o)){if(e&&e.match(/^\w/)){let t=i.find("#"+e);t&&-1===l.indexOf(t)&&l.push(t),t=i.find("[name='"+e+"']"),t&&-1===l.indexOf(t)&&l.push(t);const s=Array.from(i.findAll("."+e)).filter((e=>l.indexOf(e)<0));s.length>0&&s.forEach((e=>l.push(e)))}const t=Array.from(i.findAll(e)).filter((e=>l.indexOf(e)<0));t.length>0&&t.forEach((e=>l.push(e)))}}catch(t){return console.error("Invalid selector: "+e),void console.log(t)}if(l.length>1){const t=[];l.forEach((s=>{t.push(this.render(s,e,o))})),this.linkNode(i,e,t),void 0!==o.warn&&!1===o.warn||(console.log("Multiple elements were assigned with key: ["+e+"] under node: "),console.log(i),console.log("It might be what we expect, but if it is not expected it could result on some elements mistakenly rendered. You can specify 'warn : false' under that element to hide this message."))}else if(1===l.length){const r=l[0];if(t.utils.isElement(r)){const l=this.plainToObject(r,o),a=t.utils.isPlainObject(l)&&Object.keys(l).length>=1?Object.keys(l)[0]:null;if(a&&(o=this.updateValue(r,a,n)),t.utils.isArray(o)){const t=s.template;this.doItems(r,o,t),this.linkNode(i,e,r)}else this.renderAndLink(i,r,e,o)}else console.error("BUG: It should have been a node but got: "),console.log(r),console.log("Parent node:"),console.log(i)}else if(0===l.length){"template"===e&&void 0===s.items&&(e="items",o=[]);const n=t.utils.isFunction(o);if(void 0!==o.tagName){const t=this.appendElement(i,o.tagName);this.renderAndLink(i,t,e,o)}else if(t.utils.isValidElement(e)&&!n){const t=this.appendElement(i,e);this.renderAndLink(i,t,e,o)}else if("items"===e){const e=s.template;if(t.utils.isPlainObject(o)){const e=[];Object.keys(o).forEach((s=>{let n;"DL"===i.tagName?n={dt:s,dd:o[s]}:(n={text:o[s]},t.utils.hasAttrOrProp(i,"value")?n.value=s:n.dataset={id:s}),e.push(n)})),o=e}t.utils.isArray(o)?this.doItems(i,o,e):(console.log("Warning: 'items' specified but value is not and array, in element: "),console.log(i),console.log("Passed values are: "),console.log(o))}else n?(t.updates&&"onupdate"===e&&i.addEventListener("update",o,!0),i[e]=o):"template"!==e&&"warn"!==e&&!1!==o&&(void 0!==s.warn&&!1===s.warn||(console.error("Not sure what you want to do with key: "+e+" under element: "),console.log(i),console.log("And object:"),console.log(s),console.log("Most likely the element's property or child no longer exists or the value passed to it is incorrect."),console.log("You can set 'warn : false' property to the element to dismiss this message.")),i[e]=o)}}})),i.onload){const e=["BODY","FRAME","IFRAME","IMG","LINK","SCRIPT","STYLE"].indexOf(i.tagName)>=0,t="INPUT"===i.tagName&&"image"===i.type;e||t||i.dispatchEvent(new CustomEvent("load"))}return i}isUpdateLink(e){let s=!1;if(t.utils.isArray(e)&&(2===e.length||3===e.length)){const i=2===e.length,n=t.utils.isNode(e[0])||e[0]instanceof DOMStringMap||e[0]instanceof CSSStyleDeclaration,o=i?t.utils.isString(e[1]):t.utils.isString(e[1])&&t.utils.isFunction(e[2]);s=n&&o,s&&i&&e.push((e=>e))}return s}plainToObject(e,s){if(!t.utils.isPlainObject(s)&&!t.utils.isFunction(s)&&!t.utils.isElement(s))if(t.utils.isHtml(s))s={html:s};else if(this.isUpdateLink(s)){const i=s[0],n=s[1],o=s[2];let l=this.plainToObject(e,o(i[n]));if(t.utils.isPlainObject(l)){const e={};Object.keys(l).forEach((t=>{e[t]=s})),s=e}}else t.utils.isArray(s)?s={items:s}:t.utils.hasAttrOrProp(e,"value")?s="SELECT"===e.tagName?{value:s,text:s}:"BUTTON"===e.tagName?{text:s}:{value:s}:t.utils.isString(s)&&"IMG"===e.tagName?s={src:s}:t.utils.isString(s)&&"A"===e.tagName&&e.hasAttribute("href")?s={href:s}:(t.utils.isString(s)||t.utils.isNumeric(s))&&(s={text:s});return s}renderAndLink(e,t,s,i){const n=this.render(t,s,i);this.linkNode(e,s,n)}render(e,t,s){return s=this.plainToObject(e,s),this.doDom(e,s)}linkNode(e,s,i){if(e[s]===i){const t=this.proxy(i);try{e[s]=t}catch(e){}e["$"+s]=t}else t.utils.hasAttrOrProp(e,s)?(e["$"+s]=i,console.log("Property : "+s+" existed in node: "+e.tagName+". Using $"+s+" instead for node: "+i.tagName+".")):e[s]=this.proxy(i)}appendElement(e,s){const i=t.utils.newElement(s);return e.append(i),i}getItem(e,t,s,i){i||(i=this.getTemplate(e));const n=i.cloneNode(!0);this.addTemplatesToItem(i,n),n.dataset.id=t,this.setUniqueAttrib(n,"selected"),this.addTemplatesToObjectDeep(i,s);let o=this.doDom(n,s);return this.getItemWithEvents(e,o)}addTemplatesToObjectDeep(e,s){t.utils.isPlainObject(s)&&Object.keys(s).forEach((t=>{e[t]&&e[t].__template&&!s.template&&(s[t].template=e[t].__template),e[t]&&s[t]&&this.addTemplatesToObjectDeep(e[t],s[t])}))}addTemplatesToItem(e,t){["_template","__template"].forEach((s=>{void 0!==e[s]&&(t[s]=e[s])}))}getItemWithEvents(e,s){if(void 0!==e.__template){const i=(e,s)=>(s=s||{},Object.keys(e).forEach((n=>{t.utils.isPlainObject(e[n])?s[n]=i(e[n]):t.utils.isFunction(e[n])&&(s[n]=e[n])})),s);let n=i(e.__template);t.utils.isEmpty(n)||(n=n[Object.keys(n)[0]],s=this.doDom(s,n))}return s}doItems(e,t,s){const i=this.getTemplate(e,s);if(void 0===i)return console.error("Template not found. Probably an array is being used where it is not expected. Node:"),console.log(e),console.log("Value (mistaken?):"),void console.log(t);let n=0;t.forEach((t=>{t=this.plainToObject(e,t);const s=this.getItem(e,n++,t,i);s&&e.append(s)}));const o=e.find("template");o&&e.removeChild(o),e.items=e.children,this.extendItems(e)}getTemplate(e,s){if(void 0!==e._template&&""!==e._template)return e._template;{let i;const n=e.querySelector("template");if(n)i=t.utils.htmlElement(n.innerHTML.trim());else switch(e.tagName){case"SELECT":case"DATALIST":i=t.utils.newElement("option");break;case"UL":case"OL":i=t.utils.newElement("li");break;case"NAV":i=t.utils.newElement("a");break;case"DL":i=t.utils.newElement("dd");break;default:if(s&&t.utils.isPlainObject(s)){const n=Object.keys(s).length;if(n){if(n>1)if(void 0!==s.tagName){let e={};e[s.tagName]=s,s=e}else console.log("Template has more than one top elements. Using the first one. In: "),console.log(s),console.log("Node: "),console.log(e);const o=Object.keys(s)[0],l=s[o];t.utils.isValidElement(o)?i=t.utils.newElement(o):void 0!==l.tagName?(i=t.utils.newElement(l.tagName),s[l.tagName]=l,delete s[o]):(console.error("Template defined an element which can not be identified: ["+o+"], using <span> in:"),console.log(s),console.log("Node: "),console.log(e),i=t.utils.newElement("span"))}else console.error("Template has no definition, and it can not be guessed. Using <span>. Template: "),console.log(s),console.log("Node: "),console.log(e),i=t.utils.newElement("span")}else e.childElementCount>0&&(i=t.utils.htmlElement(e.innerHTML.trim()))}if(s)if(t.utils.isPlainObject(s)){const n=t.utils.newEmptyNode();n.append(i),i=this.doDom(n,s).children[0],t.utils.defineProp(e,"__template",s)}else i=t.utils.isHtml(s)?t.utils.htmlElement(s):t.utils.isSelectorID(s)?t.utils.htmlElement(document.querySelector(s).innerHTML):t.utils.newElement(s);if(i)if(i.childrenElementCount>1){console.log("Templates only supports a single child. Multiple children were detected, wrapping them with <span>. Template:"),console.log(i);const e=t.utils.newElement("span");e.append(i),i=e}else t.utils.defineProp(e,"_template",i);else console.log("Template was not found for element, using <span>:"),console.log(e),i=t.utils.newElement("span");return i}}setUniqueAttrib(e,s){e.hasOwnProperty(s)||Object.defineProperty(e,s,{get:function(){return this.hasAttribute(s)},set:function(e){this.parentNode&&this.parentNode.findAll("["+s+"]").forEach((e=>{e.removeAttribute(s)})),t.utils.setAttr(this,s,e)}})}updateValue(e,s,i){if(this.isUpdateLink(i)){const n=this,o=i[0],l=i[1],r=i[2];if(i=o[l],o instanceof CSSStyleDeclaration&&this._stored.styles.includes(o)){const i=this._stored.styleNodes[this._stored.styles.indexOf(o)];t.updates&&(i.onupdate=function(t){t.detail&&"style"===t.detail.property&&t.detail.newValue.startsWith(l+":")&&n.setShortValue(e,s,r(this.style[l]))})}else if(o instanceof DOMStringMap&&this._stored.datasets.includes(o)){const i=this._stored.datasetNodes[this._stored.datasets.indexOf(o)];t.updates&&(i.onupdate=t=>{t.detail&&t.detail.property==="data-"+l&&n.setShortValue(e,s,r(t.detail.newValue))})}else t.updates&&(o.onupdate=i=>{i.detail&&i.detail.property===l&&(t.utils.isObject(e[s])||n.setShortValue(e,s,r(i.detail.newValue)))})}return i}setShortValue(e,s,i){if(t.utils.isNode(e[s]))if(t.short){const n=this.plainToObject(e[s],i),o=t.utils.isPlainObject(n)&&Object.keys(n).length>=1?Object.keys(n)[0]:null;o&&(e[s][o]=i)}else console.log("Short is disabled. Trying to set a value ("+i+") in a node:"),console.log(e[s]),console.log("Either turn on 'short' functionality, or be sure you specify the property, like: 'node.text'");else e[s]=i}getShortValue(e,s,i){let n=null;if(t.utils.isNode(e[s]))if(t.short){const o=this.plainToObject(e[s],i||""),l=t.utils.isPlainObject(o)&&Object.keys(o).length>=1?Object.keys(o)[0]:null;l&&(n=e[s][l])}else console.log("Short is disabled. Trying to get a value from node:"),console.log(e[s]),console.log("Either turn on 'short' functionality, or be sure you specify the property, like: 'node.text'");else n=e[s];return n}proxy(e,s){return!t.short||null===e||void 0!==e.domNode&&void 0===s?e:(e.domNode=e,new Proxy(e,{get:(e,s)=>{const i=e[s];switch(!0){case null==i:return null;case t.utils.isFunction(i):return i.bind(e);case i.domNode&&void 0!==e["$"+s]:return e["$"+s];case void 0===i.domNode&&t.utils.isElement(i):return this.proxy(i);default:return i}},set:(e,s,i)=>{let n="";return t.utils.isElement(e[s])?(n=this.getShortValue(e,s,i),this.setShortValue(e,s,i)):"onupdate"===s?t.updates?t.utils.isFunction(i)?(e.addEventListener("update",i,!0),n=e[s],e[s]=i):(console.error("Value passed to 'onupdate' is incorrect, in node:"),console.log(e),console.log("Value: (not a function)"),console.log(i)):(console.log("Updates are not available when `m2d2.updates == false`:"),console.log(e)):"items"===s?(e.items.clear(),this.doItems(e,i)):(n=e[s],i=this.updateValue(e,s,i),e[s]=i),t.updates&&void 0!==e.onupdate&&i!==n&&e.dispatchEvent(new CustomEvent("update",{detail:{type:typeof i,property:s,newValue:i,oldValue:n}})),!0}}))}onObserve(e,s){e.forEach((e=>{const s=e.target;if(!(this._stored.events.indexOf(e)>=0)&&(this._stored.events.push(e),setTimeout((()=>{const t=this._stored.events.indexOf(e);t>=0&&this._stored.events.splice(t,1)}),t.storedEventsTimeout),void 0!==s.onupdate))if("attributes"===e.type){const i=t.utils.getAttrOrProp(s,e.attributeName);i!==e.oldValue&&s.dispatchEvent(new CustomEvent("update",{detail:{type:typeof i,property:e.attributeName,newValue:i,oldValue:e.oldValue}}))}else if("childList"===e.type)if("#text"===(e.addedNodes[0]||e.removedNodes[0]).nodeName){const t=e.addedNodes[0].textContent,i=e.removedNodes.length?e.removedNodes[0].textContent:null;t!==i&&s.dispatchEvent(new CustomEvent("update",{detail:{type:typeof t,property:"text",newValue:t,oldValue:i}}))}else if(void 0!==s.items){const t=e.addedNodes,i=e.removedNodes;t!==i&&s.dispatchEvent(new CustomEvent("update",{detail:{type:typeof t,property:"items",newValue:t,oldValue:i}}))}}))}observe(e){if(t.updates){const t=new MutationObserver(this.onObserve.bind(this)),s={attributeOldValue:!0,subtree:!0,childList:!0},i=e.domNode||e;t.observe(i,s)}}getProxyNode(e,t){const s=this.doDom(e,t);if(s)return this.observe(s),this.proxy(s)}extendItems(e){function s(t){t.forEach((t=>{const s=t.parentNode.removeChild(t);e.append(s)}))}const i=e.items;Object.getOwnPropertyNames(Array.prototype).concat(["clear","get","remove","selected","unselect","first","last","findAll"]).forEach((n=>{if(void 0===i[n]){let o=null;const l=this;switch(n){case"copyWithin":case"fill":case"splice":o=function(){console.log("Not available yet: "+n)};break;case"reverse":o=function(...e){if(this.items.length){const t=Array.from(this.items),i=t[n](...e);return s(t),i}};break;case"clear":o=function(){for(;this.items[0];)this.items[0].remove()};break;case"get":o=function(e){let s=null;return this.items.length&&this.items.some((i=>{const n=t.utils.isNumeric(e)?1*i.dataset.id==1*e:i.dataset.id===e;if(i.dataset&&n)return s=i,!0})),s};break;case"selected":o=function(){return l.proxy(this.find(":scope > [selected]"))};break;case"unselect":o=function(){if(this.items.length){const e=this.items.selected();e&&(e.selected=!1)}};break;case"first":o=function(){return l.proxy(this.items[0])};break;case"last":o=function(){return l.proxy(this.items[this.items.length-1])};break;case"pop":o=function(){if(this.items.length){const e=this[0].parentNode;return l.proxy(e.removeChild(this.items[this.items.length-1]))}};break;case"push":o=function(e){if(e=l.plainToObject(this,e),t.utils.isElement(e))this.append(e);else if(t.utils.isPlainObject(e)){const t=this.items.length,s=l.getItem(this,t,e);this.appendChild(s)}else console.log("Trying to push an unknown value into a list:"),console.log(e)};break;case"remove":o=function(e){if(this.items.length){const t=this.items.get(e);1===t.length&&t.remove()}};break;case"shift":o=function(){if(this.items.length){const e=this.items[0].parentNode;return l.proxy(e.removeChild(this.items[0]))}};break;case"sort":o=function(e){if(this.items.length){const t=Array.from(this.items);t.sort(e||((e,t)=>e.text.localeCompare(t.text))),s(t)}};break;case"unshift":o=function(e){if(e=l.plainToObject(this,e),t.utils.isElement(e))this.prepend(e);else if(t.utils.isPlainObject(e)){const t=this.items.length,s=l.getItem(this,t,e);this.prepend(s)}else console.log("Trying to unshift an unknown value into a list:"),console.log(e)};break;default:let i=n;switch(!0){case"findAll"===n:i="filter";case t.utils.isFunction(Array.prototype[n]):const s=function(...t){const s=[];return Array.from(e.items).forEach((e=>{s.push(l.proxy(e))})),Array.from(s)[i](...t)};switch(n){case"find":o=function(...e){return t.utils.isString(e[0])?this.find(e[0]):s(...e)};break;case"findAll":o=function(...e){return 0===e.length?this.findAll():t.utils.isString(e[0])?this.findAll(e[0]):s(...e)};break;case"concat":o=function(...e){for(let s=0;s<e.length;s++)if(t.utils.isArray(e[s]))for(let i=0;i<e[s].length;i++){let n=e[s][i];if(!t.utils.isElement(n)&&(n=l.plainToObject(this,e[s][i]),t.utils.isPlainObject(n))){const e=this.items.length;n=l.getItem(this,e,n)}this.items.push(n)}};break;default:o=s}}}o&&t.utils.defineProp(i,n,o.bind(e))}}))}}return t}));
//# sourceMappingURL=m2d2.min.js.map
